#ifndef __COLLAR_H__
#define __COLLAR_H__

#include "common.h"


class Myangle {
public:
   double angle;
   int p;
   int type;
   Mesh *seg;
};

bool operator<(const Myangle & a, const Myangle & b);

class Collar {
public:
   PLC * C;
   Mesh *M;

// orientation is essential...
   map < int, int >col2next;    // collar point to neighbor
   map < int, int >col2prev;    // collar point to neighbor
   map < int, int >col2e;       // collar point to edge point
   map < int, int >col2p;       // collar point to input point
   map < int, set < int > >p2col;       // map from input points to the collar around it
// this is really temporary as the collar is formed...
   map < int, Mesh * >col2m;    // map from collar point back to the associated segment...

   Collar(Mesh * m);

   int BuildCollar();
   int BuildCollarFull();       // build collar on every edge...

   Point GetCollarPoint(int prev, int cur, int next, Vector NormalInFace);

   int CollarEdge(Mesh * m);
   int ConnectEndBalls();
   void ConnectEndBallsOld();

   int SplitCollar(int a, int b);
   int SplitCollarReverse(int a, int b);
   int SplitCollar3(int a, int b, int &loc);

   bool Exists(int a, int b);
   bool Exists(int a);

   int CollarInputPoint(int iP);

   void Print();

private:

   void SegNeighbors(Mesh * m, int i, int &n1, int &n2);

   void InsertPointInMeshes(int loc, Mesh * m, bool lazyPoint, int inpoint);

};

#endif                          // !defined(__COLLAR_H__)
