#ifndef __CONFIGURATION_H__
#define __CONFIGURATION_H__

#include <iostream>
#include <string>
#include <vector>
#include <set>

#include "common.h"

#include "iniparser.h"

using namespace std;


class Configuration {
public:

   double epsilon;
   double infinity;

   double maxradiusedgeratio;
   double maxsliverangle;
   double boundingboxratio;
   double maxoutputradius;
   double hsq;
   
   int step2asplitfactor;
   int maxiterations;

   bool exactinsphere;
   bool inexactsliverinsphere;
   bool protectallsegments;
   bool lazyvertexprotection;

   bool printtplc;
   bool printraw;
   bool printtetview;
   bool printoff;
   bool printgmv;
   bool printfreefem;
   bool printintermediate;
   bool printmonochrome;

   bool colorcollar;

   bool removeboundingbox;

   bool verbose;

   bool useintestine;

   set <int> planestoprint;  // needs to be reimplemented in config
   int facetoprint;

   PLC *C;

   Configuration(PLC * C1);
   void ReadConfiguration(string fname);
   void PrintConfiguration();
   void LogConfiguration();

   dictionary * ini;

private:
};

#endif              // !defined(__CONFIGURATION_H__)
