#ifndef __POINTS__
#define __POINTS__

#include <map>
#include <set>
#include <vector>

#include "common.h"


enum PointType { POINT_BBOX, POINT_INPUT, POINT_SEGMENT, POINT_COLLAR, 
		 POINT_RING, POINT_SPHERE, POINT_CYLINDER, POINT_FACE, POINT_3D };

class Points {
public:

   Points();
   Points(Points * P);

   void CopyPoints(Points * P);
   void RemovePoints(int num);

   vector < Point > V;          // points
   vector < PointType > type;   // POINT_BBOX, POINT_3D, etc

   map < int, int >ids;         // map from point's index to its id in the datafile...
   map < int, int >id2loc;      // id to loc map from input...

   map < int, set < Mesh * > >l2m;      // list of containing meshes...
   vector < int >parent;        // this is not really used at this point...

   int AddPoint(Point p, PointType t);
   int AddPoint(Point p, int hint, PointType t);
   int AddPoint(int id, Point p, PointType t);

   bool IsIn(int p, Mesh * m);

   bool IsIntestine(int i);

   void print(Simplex * s);

// 9-19-08: remove these?
   void print(set < int >s);
   void print(vector < int >v);

   Mesh *LowestDimensionalContainingMesh(int p);
// improve to make this more efficient?
};

ostream & operator<<(ostream &, PointType);

#endif                          // !defined(__POINTS__)
