#ifndef __BOUNDARY_H__
#define __BOUNDARY_H__

#include "common.h"

class Boundary {
public:
   PLC * C;
   Mesh *M;

   set < Mesh * >segments;
   vector < Mesh * >seglist;

// orientation is essential...
   map < int, int >next;        // point to neighbor along boundary
   map < int, int >prev;        // point to neighbor along boundary

   Boundary(Mesh * m);

   void InsertPoint(int i, int n1, int n2);

   void Build();

   bool Exists(int a, int b);
   bool Exists(int a);

   void Print();

private:

   void SegNeighbors(Mesh * m, int i, int &n1, int &n2);
   void StartBoundary(Mesh * seg1, Mesh * seg2, int &first, int &second);
   int NextPoint(Mesh * seg, int current);


};
#endif                          // __BOUNDARY_H__
