#ifndef __Common_H__
#define __Common_H__


#include <iostream>
#include <fstream>
#include <iomanip>
#include <math.h>
#include <vector>
#include <time.h>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <deque>

// utility macros
#define ar_abs(x)   ((x) >= 0 ? x : -(x));
#define ar_min(x,y) ((x) < (y) ? (x) : (y));
#define ar_max(x,y) ((x) > (y) ? (x) : (y));

#include "point.h"

#include "foreach.hpp"
#define foreach BOOST_FOREACH

// forward declarations of everything...
class Points;
class Mesh;
class SimplexPool;
class PLC;
class Collar;
class Intestine;
class Boundary;
class Configuration;
class Stats;
class Geometry;
class Simplex;
class SimplexMesh;
class PointMesh;
class CollarMesh;
class IntestineItem;

struct Face {
   Simplex *s;
   int v;
};


#endif                          //__Common_H__
