#include <stdlib.h>

#include "allh.h"

Points::Points()
{
  // create a "sandbox" tet...
  /* // this doesn't work...
  Point p1(0.0,0.0,0.0);
  Point p2(1.0,0.0,0.0);
  Point p3(0.0,1.0,0.0);
  Point p4(0.0,0.0,1.0);

  AddPoint(p1,POINT_BBOX);
  AddPoint(p2,POINT_BBOX);
  AddPoint(p3,POINT_BBOX);
  AddPoint(p4,POINT_BBOX);
  */
}

Points::Points(Points * P)
{
   CopyPoints(P);
}

void Points::CopyPoints(Points * P)
{
   // copy constructor...
   // WARNING: does not copy l2m!!!
   for (int i = 0; i < (int)P->V.size(); i++) {

      V.push_back(P->V[i]);
      type.push_back(P->type[i]);
      parent.push_back(P->parent[i]);
   }

   ids = P->ids;
}

void Points::RemovePoints(int num) {
  
  int oldsize = V.size();

  V.resize(oldsize - num);
  type.resize(oldsize - num);
  parent.resize(oldsize - num);
  

}


// note: the ordering of the int and point arguments is important below
// if the int is first, it is treated as an ID for the point...
// otherwise it is treated as a hint or parent vertex...
int Points::AddPoint(int id, Point p, PointType t)
{
   id2loc[id] = V.size();
   ids[V.size()] = id;

   V.push_back(p);
   type.push_back(t);
   parent.push_back(-1);
   return V.size() - 1;
}

int Points::AddPoint(Point p, PointType t)
{
   V.push_back(p);
   parent.push_back(-1);
   type.push_back(t);
   return V.size() - 1;
}

int Points::AddPoint(Point p, int hint, PointType t)
{
   V.push_back(p);
   parent.push_back(hint);
   type.push_back(t);
   return V.size() - 1;
}

bool Points::IsIn(int p, Mesh * m)
{
   if (l2m[p].find(m) != l2m[p].end()) {
      return true;
   }
   return false;
}


// FIXME: set up the ordering on meshes so this only requires
//      reading off the first mesh in the set...
Mesh *Points::LowestDimensionalContainingMesh(int p)
{
   if (type[p] == POINT_INPUT || type[p] == POINT_BBOX) {
      cout << "ERROR: bad point passes to LowestDimensionalContainingMesh" << endl;
      exit(0);
   }

   int dmin = 100;
   Mesh * mmin = NULL;
   foreach(Mesh * m, l2m[p]) {
      if (m->dim < dmin) {
	mmin = m;
	dmin = m->dim;
      }
   }
   if (mmin == NULL) {
     cout << "ERROR: Points::LowestDimensionalContainingMesh failed" << endl;
     
     cout << p << " " << V[p] << " " << type[p] << endl;
     foreach(Mesh * m, l2m[p]) {
       cout << "Mesh " << m->name << " " << m->dim << endl;
     }
     exit(0);

   }

   return mmin;

   /* // old version..
   int dim = 3;
   if (type[p] == POINT_SEGMENT) {
      dim = 1;
   }
   if (type[p] == POINT_FACE || type[p] == POINT_COLLAR) {
      dim = 2;
   }

   foreach(Mesh * m, l2m[p]) {
      if (m->dim == dim) {
         return m;
      }
   }
   cout << "ERROR: Points::LowestDimensionalContainingMesh failed" <<
   endl;

   cout << p << " " << V[p] << " " << type[p] << endl;
   foreach(Mesh * m, l2m[p]) {
      cout << "Mesh " << m->name << " " << m->dim << endl;
   }

   exit(0);

   return NULL;
   */

}


void Points::print(Simplex * s)
{
   for (int i = 0; i < s->size(); i++) {
      cout << V[s->v[i]] << " ";
   } cout << endl;
}

// these prints have been outdated by overloading the cout operator...
void Points::print(set < int >s)
{
   foreach(int i, s) {
      cout << V[i] << " ";
   } cout << endl;
}
void Points::print(vector < int >v)
{
   for (int i = 0; i < (int)v.size(); i++) {
      cout << V[v[i]] << " ";
   } cout << endl;
}


ostream & operator<<(ostream & output, PointType t)
{

   if (t == POINT_BBOX) {
      output << "POINT_BBOX";
   }
   if (t == POINT_INPUT) {
      output << "POINT_INPUT";
   }
   if (t == POINT_SEGMENT) {
      output << "POINT_SEGMENT";
   }
   if (t == POINT_COLLAR) {
      output << "POINT_COLLAR";
   }
   if (t == POINT_RING) {
      output << "POINT_RING";
   }
   if (t == POINT_CYLINDER) {
      output << "POINT_CYLINDER";
   }
   if (t == POINT_SPHERE) {
      output << "POINT_SPHERE";
   }
   if (t == POINT_FACE) {
      output << "POINT_FACE";
   }
   if (t == POINT_3D) {
      output << "POINT_3D";
   }

   return output;
}

bool Points::IsIntestine(int loc) {
  if (type[loc] == POINT_RING ||
      type[loc] == POINT_CYLINDER ||
      type[loc] == POINT_SPHERE) {
    return true;
  }
  return false;
}
