#include "allh.h"

SimplexMesh::SimplexMesh()
{
   s = NULL;
   m = NULL;
}

PointMesh::PointMesh()
{
   p = -1;
   m = NULL;
}

CollarMesh::CollarMesh()
{
   a = -1;
   b = -1;
   m = NULL;
}

IntestineItem::IntestineItem() {
  a = -1;
  b = -1;
  c = -1;
}

void IntestineItem::sort() {
  if (a < b) { 
    int tmp = a;
    a = b;
    b = tmp;
  }

  if (b < c) {
    int tmp = b;
    b = c;
    c = tmp;
  }

  if (a < b) { 
    int tmp = a;
    a = b;
    b = tmp;
  }
  
}


bool operator<(const SimplexMesh & x, const SimplexMesh & y)
{

   double rx, ry;
   rx = x.s->rsq;
   ry = y.s->rsq;

   if (x.m->dim < y.m->dim) {
      return true;
   } else if (x.m->dim == y.m->dim && rx > ry) {
      return true;
   } else if (rx == ry && x.m->dim == y.m->dim && x.s < y.s) {
      // future... us GID...
      return true;
   }
   return false;
}



bool operator<(const PointMesh & x, const PointMesh & y)
{
   if (x.p < y.p) {
      return true;
   } else if (x.p == y.p && x.m->dim < y.m->dim) {
      return true;
   } else if (x.p == y.p && x.m->dim == y.m->dim && x.m < y.m) {
      // future... us GID...
      return true;
   }
   return false;
}


bool operator<(const CollarMesh & x, const CollarMesh & y)
{
   if (x.a < y.a) {
      return true;
   } else if (x.a == y.a && x.b < y.b) {
      return true;
   } else if (x.a == y.a && x.b == y.b && x.m < y.m) {
      // future... us GID...
      return true;
   }
   return false;
}

bool operator<(const IntestineItem & x, const IntestineItem & y)
{
  if (x.c == -1 && y.a != -1) {
    return true;
  }
  if (x.c != -1 && y.a == -1) {
    return false;
  }

   if (x.a < y.a) {
      return true;
   } else if (x.a == y.a && x.b < y.b) {
      return true;
   } else if (x.a == y.a && x.b == y.b && x.c < y.c) {
      return true;
   }
   return false;
}
