#ifndef __SIMPLEX_H__
#define __SIMPLEX_H__

enum SimplexFlag
{ SIM_NOT_QUEUED, SIM_QUEUED, SIM_CURRENT, SIM_REMOVED, SIM_DELETED,
  SIM_BBOX_STRIP };

#include "common.h"

ostream & operator<<(ostream & output, SimplexFlag f);

//
// a simplex is just a list of up to four point locations
// and an associated size of the simplex...
//
class Simplex {
public:

   Simplex();
   Simplex(Simplex * s);

   Simplex(int a);
   Simplex(int a, int b);
   Simplex(int a, int b, int c);
   Simplex(int a, int b, int c, int d);

// list of vertices in the simplex
   int v[4];
// list of neighbors
   Simplex *n[4];
// IMPORTANT: n[0] is through the 123 face
// IMPORTANT: n[1] is through the 023 face
// IMPORTANT: n[2] is through the 013 face
// IMPORTANT: n[3] is through the 012 face

   SimplexFlag f;               // stores the status of the simplex...
// eventually may keep more info?
// arand: 9-19-08.  The simplex flag should not be necessary

// these must be set externally,
// since the smiplex does not know where the points are
   double rsq;
   Point cc;

// need 1D and 2D versions of these...
   void set(int a, int b, int c, int d);
   void link(Simplex * s1, Simplex * s2, Simplex * s3, Simplex * s4);
   int isNeighbor(Simplex * s);

   void SetVertex(int i, int myv);
   void SetNeighbor(int i, Simplex * myn);

   bool contains(int i);
   bool ncontains(Simplex * i);

   void Faces(vector<Simplex> & faces);

   int size();

// useful utilities...
   bool Verify();
   friend ostream & operator<<(ostream &, Simplex *);

protected:

private:
};

bool operator<(Simplex & x, Simplex & y);

bool operator<(const Face & x, const Face & y);

#endif                          // !defined(__Some_h__)
