#include "allh.h"


using namespace std;


SimplexPool::SimplexPool()
{

   reuse = NULL;

   newsimplices = new Simplex[POOL_SIZE];
   nextsimplex = 0;
   size = POOL_SIZE;
}

Simplex *SimplexPool::NewSimplex()
{
   Simplex *newsimplex = NULL;

   if (reuse != NULL) {
      // try to reuse first...
      newsimplex = reuse;
      reuse = newsimplex->n[0];

      //if (newsimplex->f != SIM_DELETED) {
      //  cout << "Simplex ERROR" << endl;
      //}


   } else if (nextsimplex < POOL_SIZE) {
      // get the next in the pool...
      newsimplex = &newsimplices[nextsimplex];
      nextsimplex++;
   } else {
      size += POOL_SIZE;

      //cout << "Allocating more space " << size  << endl;
      // allocate more space...
      newsimplices = new Simplex[POOL_SIZE];
      nextsimplex = 0;
      newsimplex = &newsimplices[nextsimplex];
      nextsimplex++;
   }

   newsimplex->v[0] = -1;
   newsimplex->v[1] = -1;
   newsimplex->v[2] = -1;
   newsimplex->v[3] = -1;
   newsimplex->n[0] = NULL;
   newsimplex->n[1] = NULL;
   newsimplex->n[2] = NULL;
   newsimplex->n[3] = NULL;
   newsimplex->f = SIM_NOT_QUEUED;
   newsimplex->rsq = -1.0;

   //cout << "New Simplex " << nextsimplex << endl;

   return newsimplex;
}

Simplex *SimplexPool::NewSimplex(int a)
{
   Simplex *newsimplex = NewSimplex();
   newsimplex->v[0] = a;

   return newsimplex;

}

Simplex *SimplexPool::NewSimplex(int a, int b)
{
   Simplex *newsimplex = NewSimplex();
   newsimplex->v[0] = a;
   newsimplex->v[1] = b;

   return newsimplex;

}

Simplex *SimplexPool::NewSimplex(int a, int b, int c)
{
   Simplex *newsimplex = NewSimplex();
   newsimplex->v[0] = a;
   newsimplex->v[1] = b;
   newsimplex->v[2] = c;

   return newsimplex;

}

Simplex *SimplexPool::NewSimplex(int a, int b, int c, int d)
{
   Simplex *newsimplex = NewSimplex();
   newsimplex->v[0] = a;
   newsimplex->v[1] = b;
   newsimplex->v[2] = c;
   newsimplex->v[3] = d;

   return newsimplex;

}

Simplex *SimplexPool::NewSimplex(Simplex * s)
{
   Simplex *newsimplex = NewSimplex();
   newsimplex->v[0] = s->v[0];
   newsimplex->v[1] = s->v[1];
   newsimplex->v[2] = s->v[2];
   newsimplex->v[3] = s->v[3];
   newsimplex->n[0] = s->n[0];
   newsimplex->n[1] = s->n[1];
   newsimplex->n[2] = s->n[2];
   newsimplex->n[3] = s->n[3];
   newsimplex->f = s->f;
   newsimplex->rsq = s->rsq;
   newsimplex->cc = s->cc;

   return newsimplex;
}

void SimplexPool::DeleteSimplex(Simplex * s)
{

    s->n[0] = reuse;
    reuse = s;

   s->rsq = -1.0;
   s->v[0] = -1;
   s->v[1] = -1;
   s->v[2] = -1;
   s->v[3] = -1;
   // n[0] points to the list of simplices to reuse...
   s->n[1] = NULL;
   s->n[2] = NULL;
   s->n[3] = NULL;
   s->f = SIM_DELETED;
}
