/////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////


#include <iostream>
#include <string>

// include the PLC class which holds a "mesh"
#include "plc.h"
#include "allh.h"
#include "foreach.hpp"


using namespace std;

int main(int argc, char *argv[])
{

    srand(302030);

    PLC * C = new PLC();

    C->M = new Mesh(C);
    C->M->bbox = 1.0;
    C->M->dim = 3;
    vector<Simplex *> initial;
    C->M->Initialize(initial);
    C->M->name = "test";


    for (int i=0; i<1000000; i++) {

	if (i%1000 == 0) {
	    cout << "Inserting Vertex " << i << endl;
	}

	int a = rand();
	int b = rand();
	int c = rand();

	int m = RAND_MAX/2;

	double x,y,z;

	x = ((double)(a - m))/((double)(m));
	y = ((double)(b - m))/((double)(m));
	z = ((double)(c - m))/((double)(m));

	Point p(x,y,z);

	//cout << p << endl;

	int loc = C->P->AddPoint(p, -1, POINT_INPUT);

	set < Simplex * >oldcavity;
	set < Simplex * >newcavity;
	C->M->InsertPoint(loc, oldcavity, newcavity);

	foreach(Simplex * sim, oldcavity) {
	  C->SP->DeleteSimplex(sim);
	}

	//set<Simplex *>::iterator sit;
	//for(sit = oldvaity.begin(); sit != oldcavity.end(); sit++) {
	// C->SP->DeleteSimplex(*sit);
	//}

    }

    C->OrientPLC();

    C->PrintTetView("testExact");

   return 0;
}
